/* Reading a small file, reversing it and then rewriting it in an atomic way */
#include <stdio.h> /* For printf, BUFSIZE*/
#include <fcntl.h> /* For O_RDONLY, O_WRONLY,O_CREAT, O_APPEND */
#include <string.h> /* strlen */

main() {
	int i, fd, bytes;
	char c, buf[BUFSIZ];
	char *filename = "temp.txt";
	char *tempfilename = "temp.tmp";


	// Open the data file
	if ((fd = open(filename, O_RDONLY)) == -1) {
		perror("open");
		return 1;
	}

	// Read the data file 
	// In this example, if the file is larger than the used buffer, 
	// all data beyond the buffer size will be ignored! 
	bytes = read(fd, buf, sizeof(buf)); /* Data in */
	printf("%d bytes were read\n", bytes);
	close(fd);
	buf[bytes] = '\0';
	printf("%s", buf);


	// Reverse the read data
	for (i=0;i<bytes/2;i++){
		c = buf[i];
		buf[i] = buf[bytes - (i+1)];
		buf[bytes - (i+1)] = c;
	}

	printf("\nRead bytes were reversed:\n%s\n", buf);

	// Open a temporary file 
	if ((fd = open(tempfilename, O_WRONLY | O_CREAT | O_TRUNC, 0600)) == -1) {
		perror("open");
		return 1;
	}

	// Write the reversed data to the temporary file
	// Note that this operation IS NOT atomic!!
	bytes = write(fd, buf, strlen(buf)); /* Data out */
	printf("%d bytes were written\n", bytes);
	close(fd);

	// Replace the original data file with the temporary file
	// This operation IS atomic!
	rename(tempfilename, filename);
	
	return 0;
}