/* Lseek example. This examples writes a number of records (5 at the beginning
   and 5 at the end of a file. In between it leaves empty space (3 records long) */
   
#include <stdio.h> 
#include <string.h> 
#include <fcntl.h> /* For O_RDWR, O_RDONLY, O_WRONLY,O_CREAT, O_APPEND */


typedef struct person{
	int id;
	char sex;
	char name[40];
} __attribute__((packed)) PERSON;


int main(int argc, char *argv[]){
	int n, fd, i;
	PERSON p;
	char *filename="users.db";
	int offset;

	if ((fd = open(filename, O_RDWR | O_CREAT, 0660)) < 0) {
		/* Open to-file */
		perror("open db");
		return 1;
	}

	// set the values in the p structure
	p.sex = 'm';
	strcpy(p.name, "Costas");

	// write 5 tuples to the file
	for (i=0; i<5; i++) {
		p.id = i;
		write(fd, (void *) &p, sizeof(p));
	}

	// leave 3 tuples worth of empty space to the file
	lseek(fd, 3*sizeof(p), SEEK_CUR);

	// write another 5 tuples to the file
	for (i=0; i<5; i++) {
		p.id = i;
		write(fd, (void *) &p, sizeof(p));
	}
	
	// rewind the file descriptor to the beginning of the file
	lseek(fd, 0, SEEK_SET);
	
	// Now read and print the respective tuples
	while((n = read(fd, (void *) &p, sizeof(p))) > 0) {
		if ( sizeof(p) != n )
			perror ("read error");
			printf("<%d,%c,%s>\n", p.id, p.sex, p.name);
	}

	close(fd);
	
	return 0;
}